// Advanced types Demo
#include <stdio.h>

int main(int argc, char* argv[])
{
	// ENUMERATION EXAMPLE
	enum Days {MONDAY, TUESDAY, WEDNESDAY, THURSDAY, FRIDAY, SATURDAY, SUNDAY};
	Days day=THURSDAY;
	printf("day=%d\n",day);
//	day=day+1;					// WRONG! No arithmetic operations between integer and an enum type
	day=(Days) ((int) day+1);	// RIGHT!
	if (day==FRIDAY) printf("day=%d\n",day);
	int numWeekdays=SATURDAY-MONDAY;// Can perform arithmetic operations between values of an enumeration type
	printf("numWeekdays=%d\n",numWeekdays);


	// STRUCTURE EXAMPLE 1
	struct Student{
		int id;
		int age;
		int stage;
	};

	struct Student stud1, stud2;
	stud1.id=2222222;
	stud1.age=99;
	stud1.stage=3;
	stud2=stud1;
	printf("The stage %d student with the ID %d is %d years old!\n", stud2.stage, stud2.id, stud2.age);

	// now the same except that we define a type 'StudentType'
	typedef struct {
		int id;
		int age;
		int stage;
	} StudentType;

	StudentType stud3, stud4;
	stud3.id=87654321;
	stud3.age=17;
	stud3.stage=1;
	stud4=stud3;
	printf("The stage %d student with the ID %d is %d years old!\n", stud4.stage, stud4.id, stud4.age);


	// STRUCTURE EXAMPLE 2
	struct Colour {	// RGB colour
		float r;	// red component in range (0,1)
		float g;	// green component in range (0,1)
		float b;	// blue component in range (0,1)
	};

	struct Colour white, myColour;
	white.r=1.0;
	white.g=1.0;
	white.b=1.0;
	myColour=white;
	printf("\nThe RGB coordinates of white colour are (%f, %f, %f)\n\n",myColour.r, myColour.g, myColour.b);

	return 0;
}
